/**
 * Twitter class
 *
 * requires base64encode function
 *
 * usage:
 *		var message = prompt('input the message');
 *		new Twitter('username', 'password').update(message);
 * 
 * copyright (c) nonn-et-twk
 *
 * @see http://groups.google.com/group/twitter-development-talk/web/api-documentation
 */
function Twitter(username, password)
{
	this.username = username;
	this.password = password;

	if (!Twitter.prototype.update)
	{
		Twitter.prototype.update = update;
		Twitter.prototype.friends_timeline = friends_timeline;
		Twitter.prototype._addRequestHeaders = _addRequestHeaders;
		Twitter.logFetchAsync = logFetchAsync;
	}

	log('twitter is initialized with ' + username);

	return;

	function logFetchAsync(url)
	{
		log('fetch to ' + url.location + ' is done by response ' + url.response); // + ' ' + url.result);
	}

	// update is async
	// @return void
	function update(message)
	{
		var url = new URL();
		url.location = "http://twitter.com/statuses/update.json";
		url.postData = 'status=' + escape(message);

		this._addRequestHeaders(url);

		// the dialog is appeared automatically in case of the authentication failure
		// 3.1.6 engine needs a global reference. 4.0 doesn't.
		url.fetchAsync(Twitter.logFetchAsync);
	} // update

	// @param option Date object
	// @return json object (array) or empty array
	function friends_timeline(since){
		var id = this.username;

		var pos = id.indexOf('@');
		if (pos >= 0)
		{
			log("may not work with this id " + id);
			id = id.substr(0, pos);
		}

		var location = 'http://twitter.com/statuses/friends_timeline/' + id + '.json';
		if (since) location += '?since=' + escape(since.toGMTString());

		var url = new URL();
		url.location = location;

		var s = url.fetch();
		Twitter.logFetchAsync(url);
		return s.substr(0,3) == '[{"' ? eval(s) : [];
	} // friends_timeline

	// @private
	function _addRequestHeaders(url)
	{
		// not working yet?
		// @see http://twitter.pbwiki.com/API%20Docs#RequestHeaders
		url.setRequestHeader("X-Twitter-Client", "ShareTunes"); 
		url.setRequestHeader("X-Twitter-Client-URL", "http://nonn-et-twk.net/twk/nondrupal/ShareTunes/twitter.xml"); 
		url.setRequestHeader("X-Twitter-Client-Version", widget.version); 

		// mac needs to set the authorization header at last
		// @see http://x68000.q-e-d.net/~68user/net/http-auth-1.html
		var base64Auth = base64encode(this.username + ':' + this.password);
		url.setRequestHeader("Authorization", "Basic " + base64Auth); 
	}
} // class Twitter
