// Provides components to achieve general web browser objects and functions
// dummies are not yet implemented but just declared to suppress parse errors
// copyright (c) twk
// 20070610

var window = typeof window != 'undefined' ? window : this;
var top = window.top || window;
var parent = window.parent || window;
// var navigator = {userAgent: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US)'}; // value of new URL().fetch()
var navigator = window.navigator || {userAgent: 'Mozilla/5.0 (compatible; '
	+ 'Konfabulator ' + konfabulatorVersion() + '; '
	+ (system.platform == 'windows' ? 'Windows' : 'Macintosh') + ')'};
var document = window.document || {
	appendChild: function(){return {};}, // dummy
	createElement: function(){return document;}, // dummy
	createTextNode: function(){return '';}, // dummy
	getElementById: function(id){return window[id] || null;}
};

// @param fn function or string
var setInterval = window.setInterval || function(fn, intervalMsec){
	if (typeof fn == 'string') fn = new Function(fn);
	var timer = new Timer();
	timer.interval = intervalMsec / 1000;
	timer.onTimerFired = fn;
	timer.ticking = true;
	widget[timer.name] = timer;
	return timer.name;
};
var clearInterval = window.clearInterval || function(timerName)
{
	widget[timerName].ticking = false;
	delete widget[timerName];
};
// @param fn function or string
var setTimeout = window.setTimeout || function(fn, timeoutMsec){
	if (typeof fn == 'string') fn = new Function(fn);
	var timer = new Timer();
	timer.interval = timeoutMsec / 1000;
	timer.onTimerFired = function(){
		timer.ticking = false;
		delete widget[timer.name];
		fn();
	}; //referring a variable timer
	timer.ticking = true;
	widget[timer.name] = timer;
	return timer.name;
};
var clearTimeout = window.clearTimeout || clearInterval;

// @return boolean
var confirm = window.confirm || function(string)
{
	return alert(string, widget.getLocalizedString('OK'), widget.getLocalizedString('Cancel'))
		== 1;
};

// It does not create intermediate directories (i.e., it does not do the equivalent of mkdir -p).
// In ver 4.0, directories can only be created inside your Widgetfs WidgetData folder.
//
// @param path note that path using double quotes and back slashes may not be created on some platforms
// @return boolean true if existed or created, false if failed to create
if (!filesystem.createDirectory) filesystem.createDirectory
= function createDirectory(path)
{
	if (filesystem.isDirectory(path)) return true;
	if (filesystem.itemExists(path)) return false; // file exists with the same name

	if (path.indexOf('"') >= 0)
	{
		if (path.indexOf('/') == -1 && path.indexOf('\\') != -1)
			path = path.replace('\\', '/');
		path = path.replace('"', '\\"');
	}

	runCommand('mkdir "' + path + '"');

	// throw "createDirectory: parent directory does not exist.";
	return filesystem.isDirectory(path);
};

// runCommand('mkdir -p "' + path + '"');
// @return boolean true if existed or created, false if failed to create
function mkdir(path, parents)
{
	if (!parents) return filesystem.createDirectory(path);

	if (path.indexOf('/') == -1 && path.indexOf('\\') != -1)
		path = path.replace('\\', '/');
	
	var lastPos = path.lastIndexOf('/');
	if (lastPos >= 0 && !mkdir(path.substr(0, lastPos), parents))
		return false;

	return filesystem.createDirectory(path);
}

// runCommand('basename "' + path + "')
// @param path slash separated
function basename(path)
{
	if (path[path.length - 1] == '/') path = path.substr(0, path.length - 1); // strip the last slash
	return path.substr(path.lastIndexOf('/') + 1);
}

// runCommand('dirname "' + path + "')
// @param path slash separated
function dirname(path)
{
	if (path[path.length - 1] == '/') path = path.substr(0, path.length - 1); // strip the last slash
	return path.substr(0, path.lastIndexOf('/'));
}
