/**
 * small boot loader
 * copy the impl file to the place and include it
 *
 * copyright (c) nonn et twk 
 */
(function (){
	var loaderImpl = system.widgetDataFolder + '/Contents/loaderImpl.js';

	var succeeded = filesystem_update('loaderImpl.js', loaderImpl);
	if (!succeeded)
		log('update failed');

	include(loaderImpl);
	return;
	
	// copy a single file (not directory copy)
	// dirname(dest) may not be created
	//
	// @return true copied or no need to copy.  false if error
	function filesystem_update(src, dest)
	{
		var succeeded = false;

		// directory copy is not supported
		if (!filesystem.itemExists(src) || filesystem.isDirectory(src) 
			|| filesystem.isDirectory(dest))
		{
			return false;
		}

		if (!filesystem.itemExists(dest))
		{
			var dirName = dirname(dest).replace('\\', '/');
			if (!filesystem.isDirectory(dirName))
				mkdir(dirName);
			succeeded = filesystem.copy(src, dest);
		}
		else
		{
			// time depends on download time so we just compares the size
			var srcSize = filesystem.getFileInfo(src).size;
			var destSize = filesystem.getFileInfo(dest).size;
			if (srcSize != destSize)
			{
				filesystem.moveToTrash(dest); // to suppress the overwrite confirm dialog
				succeeded = filesystem.copy(src, dest);
			}
			else
				succeeded = true; // no need to copy
		}
		return succeeded;

		// from compat
		// runCommand('dirname "' + path + "')
		function dirname(path)
		{
			if (path[path.length - 1] == '/') path = path.substr(0, path.length - 1); // strip the last slash
			return path.substr(0, path.lastIndexOf('/'));
		}

		// It does not create intermediate directories (i.e., it does not do the equivalent of mkdir -p).
		function mkdir(path)
		{
			if (filesystem.isDirectory(path)) return true;
			if (filesystem.itemExists(path)) return false; // file exists with the same name

			if (path.indexOf('"') >= 0)
			{
				if (path.indexOf('/') == -1 && path.indexOf('\\') != -1)
					path = path.replace('\\', '/');
				path = path.replace('"', '\\"');
			}

			runCommand('mkdir "' + path + '"');

			return filesystem.isDirectory(path);
		}
	} // filesystem_update
})();
