/**
 * check for update and eval
 * copyright (c) nonn et twk 
 */
(function (){
	var contentsFolder = system.widgetDataFolder + '/Contents';

	var isFirstTimeRun = !filesystem.itemExists(contentsFolder + '/versionInfo.js');
	if (isFirstTimeRun)
	{
		log('first run');
		// we want to show the latest stuff to new users
		var updated = CheckForRemoteUpdate();

		// this is necessary
		UpdateAllContents();

		// if network error, try updating again
		if (updated === null)
			filesystem.moveToTrash(contentsFolder + '/versionInfo.js');

		if (updated)
			reloadWidget();
	}
	else if (CheckForLocalUpdate())
	{
		log('local updated');
		// the user has downloaded the next version

		UpdateAllContents();
		// no reload.  loaderImpl update will effect in the next run
	}
	else
	{
		// normally, check for update in idle time not to annoy users

		var updateTimer = new Timer();
		updateTimer.name = 'updateTimer';
		updateTimer.interval = 5 * 60; // 5 minutes
		updateTimer.onTimerFired = function(){
			log('fired the update Check');

			// not try on busy
			if (system.cpu.idle < 70) return;
			
			var updated = CheckForRemoteUpdate(); // update is appeared on the next run
			
			// do not try again in one widget lifetime
			updateTimer.ticking = false;
			widget.updateTimer = null;
		};
		widget.updateTimer = updateTimer;
		updateTimer.ticking = true;
	}

	var mainSource = contentsFolder + '/ShareTunes.js';
	include(mainSource);
	return;

	// a small checker first, a heavy code next
	// @return true if updated, false if not, null if error
	function CheckForRemoteUpdate()
	{
		log('Checking for update');

		try
		{
			var versionInfoUrl = 'http://nonn-et-twk.net/twk/nondrupal/ShareTunes/Contents/versionInfo.js';
			var remoteVersionInfo = eval(filesystem_readJson(versionInfoUrl));
			if (!remoteVersionInfo['versionInfo.js'])
			{
				log('could not get version');
				return null; // maybe network error.  try again
			}
			var currentVersionInfoFile = contentsFolder + '/versionInfo.js';
			if (!filesystem.itemExists(currentVersionInfoFile)) currentVersionInfoFile = 'versionInfo.js';
			var currentVersionInfo = eval(filesystem.readFile(currentVersionInfoFile));

			if (currentVersionInfo['versionInfo.js'] >= remoteVersionInfo['versionInfo.js'])
			{
				log('current is latest.' 
					+ currentVersionInfo['versionInfo.js'] + '>=' + remoteVersionInfo['versionInfo.js']);
				return false;
			}

			if (!isNaN(remoteVersionInfo['ShareTunes.widget']) 
				&& (isNaN(currentVersionInfo['ShareTunes.widget'])
				|| currentVersionInfo['ShareTunes.widget'] < remoteVersionInfo['ShareTunes.widget']))
			{
				var msg = widget.locale == 'ja' ? '新しい版が出ました。更新しますか？'
					: 'New version is avialable.  Want to upgrade?';
				if (1 == alert(msg, 
					widget.getLocalizedString('OK'), widget.getLocalizedString('Cancel')))
				{
//					openURL('http://widgets.yahoo.co.jp/gallery/detail.html?wid=10151');
					openURL('http://nonn-et-twk.net/twk/nondrupal/ShareTunes/index.html');
					closeWidget();
				}
				else
				{
					// old versions are not updated anymore.
					return false;
				}
			}
			
			var urlBase = 'http://nonn-et-twk.net/twk/nondrupal/ShareTunes/Contents';
			for (var fileName in remoteVersionInfo)
			{
				if (currentVersionInfo[fileName] >= remoteVersionInfo[fileName])
					continue;

				var urlObject = new URL();
				urlObject.outputFile = system.widgetDataFolder + '/tempFile';
				var data = urlObject.fetch(urlBase + '/' + fileName);

				if (urlObject.response == 200)
				{
					log('downloading ' + fileName);
					filesystem_update(urlObject.outputFile, contentsFolder + '/' + fileName);
				}
			}
			if (filesystem.itemExists(system.widgetDataFolder + '/tempFile'))
				filesystem.moveToTrash(system.widgetDataFolder + '/tempFile');

			return true;
		}
		catch(e)
		{
			log(e);
			return false;
		}

		// @return {}
		function filesystem_readJson(url)
		{
			var urlObject = new URL();
			var data = urlObject.fetch(url);
			try
			{
				return urlObject.response == 200 ? eval(data) : {};
			}catch(e){
				log(e);
				return {};
			}
		}
	}

	// currently just check versionInfo lastmodified
	function CheckForLocalUpdate()
	{
//		return true;
		var src = 'versionInfo.js';
		var dest = contentsFolder + '/versionInfo.js';

		var destInfo = filesystem.getFileInfo(dest);
		if (!destInfo) return true;
/*
		var destTime = destInfo.lastModified.getTime();
		var srcTime = filesystem.getFileInfo(src).lastModified.getTime();

		return srcTime > destTime;
*/
		var srcVersionInfo = eval(filesystem.readFile(src));
		var destVersionInfo = eval(filesystem.readFile(dest));

		return srcVersionInfo['versionInfo.js'] > destVersionInfo['versionInfo.js'];
	}

	// notice that the source is the original widget folder
	function UpdateAllContents()
	{
		// local copy.  widget current -> data
		var fileList = filesystem.getDirectoryContents('.', true); // recursive
		for (var i = 0, l = fileList.length; i < l; ++i)
			filesystem_update(fileList[i], contentsFolder + '/' + fileList[i], true);
	}

	// copy a single file (not directory copy)
	// dirname(dest) may not be created
	//
	// @return true copied or no need to copy.  false if error
	function filesystem_update(src, dest, forceCopy)
	{
		var succeeded = false;

		// directory copy is not supported
		if (!filesystem.itemExists(src) || filesystem.isDirectory(src) 
			|| filesystem.isDirectory(dest))
		{
			return false;
		}

		if (!filesystem.itemExists(dest))
		{
			var dirName = dirname(dest).replace('\\', '/');
			if (!filesystem.isDirectory(dirName))
				mkdir(dirName);
			succeeded = filesystem.copy(src, dest);
			log(src + ' is copied');
		}
		else
		{
			var srcTime = filesystem.getFileInfo(src).lastModified.getTime();
			var destTime = filesystem.getFileInfo(dest).lastModified.getTime();
			if (forceCopy || srcTime > destTime)
			{
				filesystem.moveToTrash(dest); // to suppress the overwrite confirm dialog
				succeeded = filesystem.copy(src, dest);
				log(src + ' is copied');
			}
			else
			{
				succeeded = true; // no need to copy
				log(src + ' is not copied');
			}
		}
		return succeeded;

		// from compat
		// runCommand('dirname "' + path + "')
		function dirname(path)
		{
			if (path[path.length - 1] == '/') path = path.substr(0, path.length - 1); // strip the last slash
			return path.substr(0, path.lastIndexOf('/'));
		}

		// It does not create intermediate directories (i.e., it does not do the equivalent of mkdir -p).
		function mkdir(path)
		{
			if (filesystem.isDirectory(path)) return true;
			if (filesystem.itemExists(path)) return false; // file exists with the same name

			if (path.indexOf('"') >= 0)
			{
				if (path.indexOf('/') == -1 && path.indexOf('\\') != -1)
					path = path.replace('\\', '/');
				path = path.replace('"', '\\"');
			}

			runCommand('mkdir "' + path + '"');

			return filesystem.isDirectory(path);
		}
	} // filesystem_update
})();
