/*
 * Utility functions for ShareTunes
 *
 * copyright (c) nonn et twk
 */

function trim(s){
	return s.replace(/^\s+/,'').replace(/\s+$/,'');
}

// call with error handling
function e(fn)
{
	try {
		fn();
	} catch(e) {
		if (e.stack) e.message += '\n' + e.stack.replace(/@.*\/([^:\/]*:)/g, '@$1');
		throw e;
	}
}

// wrapper of e(fn) that is useful for the event handler assignment
function ee(fn)
{
	return function(){e(fn);};
}
